<template>
  <div class="main_root">
    <div class="search_header">
      <div class="search_left">
        <DatePicker
          v-model="searchForm.dataRange"
          @on-change="searchList()"
          :editable="false"
          :transfer="true"
          format="yyyy-MM-dd"
          type="daterange"
          placement="bottom-start"
          placeholder="请选择日期段"
          style="margin-right: 10px; width: 220px"
        ></DatePicker>
        <Input
          v-model="searchForm.name"
          placeholder="请输入登录名、设备号"
          search
          @on-search="searchList()"
          style="width: 180px"
        />
      </div>
      <Button type="primary" class="primary_btn" @click="toExport()"
        >导出</Button
      >
    </div>
    <div class="table_wrap">
      <Table :columns="columns" :data="searchForm.list"></Table>
    </div>
    <div class="page_wrap">
      <Page
        :transfer="true"
        :total="searchForm.total"
        :current="searchForm.page"
        :page-size="searchForm.size"
        :page-size-opts="[10, 20, 40, 60]"
        @on-change="pageChange"
        @on-page-size-change="pageSizeChange"
        show-total
        show-sizer
      ></Page>
    </div>
  </div>
</template>

<script>
import { dateFormat } from "@/utils";
import { exportToExcel } from "@/utils/exportToExcel";
import { userPosition_list, userPosition_list_all } from "@/api/log";
export default {
  data() {
    return {
      searchForm: {
        dataRange: [],
        name: "",
        page: 1,
        size: 10,
        list: [],
        total: 0
      },
      columns: [
        {
          title: "序号",
          align: "center",
          width: 70,
          render: (h, params) => {
            return h(
              "span",
              params.index +
                (this.searchForm.page - 1) * this.searchForm.size +
                1
            );
          }
        },
        {
          title: "设备号",
          key: "sn",
          align: "center"
        },
        {
          title: "登录名",
          key: "loginname",
          align: "center"
        },
        {
          title: "姓名",
          key: "username",
          align: "center"
        },
        {
          title: "学校名称",
          key: "schoolName",
          align: "center"
        },
        {
          title: "班级",
          key: "classname",
          align: "center"
        },
        {
          title: "地址",
          key: "address",
          align: "center"
        },
        {
          title: "时间",
          key: "createtime",
          width: 190,
          align: "center"
        }
      ]
    };
  },
  created() {
    this.searchList();
  },
  computed: {
    powerParams() {
      return this.$store.getters.powerParams;
    }
  },
  methods: {
    // 搜索
    searchList() {
      this.searchForm.page = 1;
      this.getList();
    },
    // 页码改变
    pageChange(page) {
      this.searchForm.page = page;
      this.getList();
    },
    // 每页显示数量改变
    pageSizeChange(size) {
      this.searchForm.size = size;
      this.searchForm.page = 1;
      this.getList();
    },
    // 获取列表
    getList() {
      let _begindate = this.searchForm.dataRange[0];
      _begindate = _begindate ? dateFormat(_begindate, "yyyy-MM-dd") : null;
      let _enddate = this.searchForm.dataRange[1];
      _enddate = _enddate ? dateFormat(_enddate, "yyyy-MM-dd") : null;
      let _regionids = this.$store.state.userPower.regionids;
      _regionids = [..._regionids];
      userPosition_list({
        rtype: this.powerParams.rtype,
        objectid: this.powerParams.objectid,
        regionid: _regionids.pop(),
        schoolid: this.powerParams.objectid,
        page: this.searchForm.page,
        size: this.searchForm.size,
        begindate: _begindate,
        enddate: _enddate,
        name: this.searchForm.name
      }).then((data) => {
        if (data.code === 0) {
          this.searchForm.list = data.obj.data;
          this.searchForm.total = data.obj.total;
        } else {
          this.$Message.error(data.msg);
        }
      });
    },
    toExport() {
      let _begindate = this.searchForm.dataRange[0];
      _begindate = _begindate ? dateFormat(_begindate, "yyyy-MM-dd") : null;
      let _enddate = this.searchForm.dataRange[1];
      _enddate = _enddate ? dateFormat(_enddate, "yyyy-MM-dd") : null;
      let _regionids = this.$store.state.userPower.regionids;
      _regionids = [..._regionids];
      userPosition_list_all({
        rtype: this.powerParams.rtype,
        objectid: this.powerParams.objectid,
        regionid: _regionids.pop(),
        schoolid: this.powerParams.objectid,
        begindate: _begindate,
        enddate: _enddate,
        name: this.searchForm.name
      }).then((data) => {
        if (data.code === 0) {
          exportToExcel(
            [
              {
                list: data.obj.map((item) => {
                  return {
                    设备号: item.sn,
                    登录名: item.loginname,
                    姓名: item.username,
                    学校名称: item.schoolName,
                    班级: item.classname,
                    地址: item.address,
                    时间: item.createtime
                  };
                }),
                name: "设备位置日志"
              }
            ],
            "设备位置日志"
          );
        } else {
          this.$Message.error(data.msg);
        }
      });
    }
  }
};
</script>

<style lang="less" scoped>
.search_header {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin: 16px 16px;
  .search_left {
    display: flex;
    justify-content: flex-start;
    align-items: center;
  }
}
</style>
